/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lib.pcrypt;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Thomas
 */
public class Tokenizer {
    
    public Tokenizer(){
        
    }
    
    public List<Token> tokenize(String str){
        List<Token> tokens = new ArrayList<>();
        
        int pos = 0;
        while (pos < str.length()){            
            Token token = new Token();
            
            if (str.charAt(pos) == ' '){
                pos++;
                continue;
            } else if (str.charAt(pos) >= 48 && str.charAt(pos) <= 57){
                StringBuilder builder = new StringBuilder();
                
                while (pos < str.length() && str.charAt(pos) >= 48 && str.charAt(pos) <= 57){
                    builder.append(str.charAt(pos));
                    pos++;
                }
                token.setType(TokenType.INTEGER);
                token.setValue(builder.toString());
                
                tokens.add(token);
                continue;
            } else if (str.charAt(pos) >= 97 && str.charAt(pos) <= 122){
                token.setType(TokenType.VARIABLE);
            } else if (str.charAt(pos) == '+'){
                token.setType(TokenType.PLUS);
            } else if (str.charAt(pos) == '-'){
                token.setType(TokenType.MINUS);
            } else if (str.charAt(pos) == '*'){
                token.setType(TokenType.MULT);
            } else if (str.charAt(pos) == '^'){
                token.setType(TokenType.EXPONENT);
            }
            token.setValue(Character.toString(str.charAt(pos)));
            tokens.add(token);
            
            pos++;
        }
        return tokens;
    }
}
